        processor 6502

; Atari logo for the 2600 VCS
; and demo using the playfield registers
; (c) October 5, 2001 Eric Ball ekball@eol.ca

VSYNC	EQU	$00
WSYNC	EQU	$02
COLUPF	EQU	$08
CTRLPF	EQU	$0A
PF0	EQU	$0D
PF1	EQU	$0E
PF2	EQU	$0F

	ORG	$1000
START:	SEI		; enable interupts
	CLD		; turn of BCD math
	LDX	#$00	; zero zero page memory & registers
	TXA
NULL:	STA	0,X
	INX
	BNE	NULL
	INX		; enable mirrored playfield
	STX	CTRLPF
TOPPF:	LDX	#$02	; turn on VSYNC for three lines
	STX	VSYNC
	STA	WSYNC
	STA	WSYNC
	STA	WSYNC
	LDX	#$00	; turn off VSYNC
	STX	VSYNC
	DEY		; colour rotation
	DEY		; 259 - 4 = 255
	DEY
	DEY
SETPF:	STA	WSYNC	; wait for start of line
	STY	COLUPF	; colour of line
	LDA	$1100,X ; update PF registers using table
	STA	PF0     ; DASM doesn't support abx with labels
	LDA	$1101,X
	STA	PF1
	LDA	$1102,X
	STA	PF2
	LDA	$1103,X	; number of identical lines
NEXTY:	INY		; increment colour
	CLC		; decrement number of lines
	SBC	#$00
	BEQ	NEXTX	; next table entry
	STA	WSYNC	; wait for start of line
	STY	COLUPF	; update colour
	BNE	NEXTY	; repeat
NEXTX:	INX		; increment table pointer
	INX
	INX
	INX
	CPX	#LOGOEND ; end of table?
	BNE	SETPF	; continue
	BEQ	TOPPF	; do vsync

	ORG	$1100	; start on new page

; logo in 40*192, created using QBasic circle()
; PF0,PF1,    PF2,count
; 45677654321001234567
; Why isn't the TIA consistent?

	DC	$00,$00,$00,37
	DC	$00,$00,$CF,45
	DC	$00,$01,$CF,1
	DC	$00,$01,$C7,30
	DC	$00,$03,$C7,7
	DC	$00,$03,$C3,12
	DC	$00,$07,$C3,11
	DC	$00,$07,$C1,4
	DC	$00,$0F,$C1,11
	DC	$00,$1F,$C1,1
	DC	$00,$1F,$C0,8
	DC	$00,$3F,$C0,6
	DC	$00,$3E,$C0,1
	DC	$00,$7E,$C0,6
	DC	$00,$FE,$C0,5
	DC	$80,$FC,$C0,3
	DC	$C0,$FC,$C0,2
	DC	$E0,$FC,$C0,1
	DC	$F0,$FC,$C0,4
	DC	$F0,$F8,$C0,8
	DC	$F0,$F0,$C0,7
	DC	$F0,$E0,$C0,5
	DC	$F0,$C0,$C0,5
	DC	$F0,$80,$C0,4
	DC	$F0,$00,$C0,2
	DC	$70,$00,$C0,2
	DC	$30,$00,$C0,1
	DC	$00,$00,$00,30
LOGOEND	EQU	112	

	ORG	$17FC	; end of 2K cart
	DC.W	START	; reset vector
	DC.W	START	; IRQ vector
